import time
import os
import serial
import sys, termios, struct, fcntl
from Util import *
from Antenna import *
from abc import *

if (sys.hexversion < 0x020100f0): import TERMIOS
else: TERMIOS = termios
if (sys.hexversion < 0x020200f0): import FCNTL
else: FCNTL = fcntl
TIOCMBIS  = hasattr(TERMIOS, 'TIOCMBIS') and TERMIOS.TIOCMBIS or 0x5416
TIOCMBIC  = hasattr(TERMIOS, 'TIOCMBIC') and TERMIOS.TIOCMBIC or 0x5417
TIOCM_DTR = hasattr(TERMIOS, 'TIOCM_DTR') and TERMIOS.TIOCM_DTR or 0x002
TIOCM_RTS = hasattr(TERMIOS, 'TIOCM_RTS') and TERMIOS.TIOCM_RTS or 0x004
TIOCM_RTS_str = struct.pack('I', TIOCM_RTS)
TIOCM_DTR_str = struct.pack('I', TIOCM_DTR)
# block == false
#fcntl.ioctl(com, TIOCMBIS, TIOCM_DTR_str) 
# block == true
#fcntl.ioctl(com, TIOCMBIC, TIOCM_DTR_str)


class SerialCommunicator(metaclass=ABCMeta):
    def __init__(self, name):
        self.Com = None
        self.ErrorCRC = 0 
        p = Thread(target=self.Worker)
        p.start()
    def Connect(self, dev_name, baudrate):
        self.Com = serial.Serial(dev_name, baudrate)
    def Worker(self):
        line = b""
        while True:
            if self.Com == None:
                time.sleep(0.1)
            else:
                ch = self.Com.read(1)
                line += ch 
                if ch == b'\n':  
                    self.ProcDat(line.decode())
                    line = b""
    def Send(self,msg):
        self.Com.write(bytes(msg, encoding='ascii'))
    def ProcDat(self, data): 
        pass
    