




def chk_uart2():
    pj.SerPcu = PcuCommunicator()
    pj.SerPcu.Connect('/dev/ttyUSB5', 57600)

def load_sas():
    import os
    conf_path = os.path.join(os.path.join(os.getcwd(),"conf"),"sas.en")
    # print(conf_path)
    import json
    file_path = conf_path
    with open(file_path, 'r') as file:
        return json.load(file)
    return None

class Project:
    def __init__(self):
        self.SerPcu = None
        self.Ant = None
    def load_conf(self):
        self.Ant = load_sas()
            
pj = Project()         




         
# import sys, termios, struct, fcntl
class SerialCommunicator:
    from abc import ABCMeta 
    __metaclass__ = ABCMeta
    def __init__(self):
        from threading import Thread
        self.Com = None
        self.Con = False 
        self.CrcErr = 0 
        self.CrcStat = False
        self.CrcCrt=0
        self.CrcMsg=''
        self.IgnStaMsg=3
        p = Thread(target=self.Worker)
        p.start()
    def Connect(self, dev_name, baudrate):
        import serial
        self.Com = serial.Serial(dev_name, baudrate)
        self.Con = True
    def Worker(self):
        import time
        line = b""
        while True:
            if self.Com == None:
                time.sleep(0.1)
            else:
                ''' check connect '''
                try:
                    ch = self.Com.read(1)
                    line += ch 
                except Exception as e: 
                    # if self.Con : print(e)
                    print(e)
                    self.Con = False
                    continue
                    
                ''' processing data '''               
                if ch == b'\n':  
                    if not self.Con : 
                        self.Con = True 
                        print('connection restored.')
                    #ignore 3 times from start message 
                    if self.IgnStaMsg>0: self.IgnStaMsg = self.IgnStaMsg - 1
                    #override    
                    self.ProcDat(line)
                    line = b""
    def Send(self,msg):
        self.Com.write(bytes(msg, encoding='ascii'))
    def ProcDat(self, line): 
        pass
    def ChkPcuCRC(self, line): 
        self.CrcStat=False
        if len(line)<6: return False 
        text = line;
        text = text.replace('\t', '').replace('\n', '').replace('\r', '')
        if text[len(text)-5] == '*':
            trimmed_text = text[0:len(text)-5]
            crc_text = text[len(text)-4:len(text)]
            crc_text_converted = int(crc_text, base=16)
            crc = 0;
            for i in trimmed_text :
                crc = 0xffff&(crc >> 8) | 0xffff&(crc << 8);
                crc ^= ord(i);
                crc ^= 0xffff&((crc & 0xff) >> 4);
                crc ^= 0xffff&(crc << 12);
                crc ^= 0xffff&((crc & 0x00ff) << 5);
            if crc == crc_text_converted: 
                if line[0:3]!="$KB":
                    self.CrcCrt=int(text[len(text)-6])
                    self.CrcMsg=line
                    self.CrcStat=True
                return True
            else: 
                return False
        return False 
    def __exit__(self, exc_type, exc_val, exc_tb):
        """Leave context: close port"""
        self.close()
        
        
        
        
class PcuCommunicator(SerialCommunicator):
    def __init__(self):
        SerialCommunicator.__init__(self)
    def ProcDat(self, line): 
        if self.ChkPcuCRC(line) == False :
            self.CrcErr = self.CrcErr + 1
            return
        arr = line.decode().split(',')
        if arr[0]=="$KB" : 
            if arr[1]=="DAT_S" and arr[2]=="STS"    : self.BurstDat(arr)
            elif arr[1]=="DAT_S" and arr[2]=="GPS"  : 
                # print(line)
                self.IntGpsDat(arr)
    def BurstDat(self, arr):
        for dat in arr:             
            for idx in range(len(pj.Ant['burst'])): 
                if dat[0:2]== pj.Ant['burst'][idx]['tag']: 
                    pj.Ant['burst'][idx]['val'] = dat[2:len(dat)]
                    # print("{0}:\t{1}".format(pj.Ant['burst'][idx]['name'], pj.Ant['burst'][idx]['val']))
                    break   
    def IntGpsDat(self, arr):
        rmc_idx = 3
        gga_idx = 16
        # print(len(pj.Ant['int-gps-rmc']))
        for i in range(0,len(pj.Ant['int-gps-rmc'])): pj.Ant['int-gps-rmc'][i] = arr[i+rmc_idx]
        for i in range(0,len(pj.Ant['int-gps-gga'])): pj.Ant['int-gps-gga'][i] = arr[i+gga_idx]
        # print(pj.Ant['int-gps-rmc'])
        # print(pj.Ant['int-gps-gga'])
        
def proc_pcu1(arr):
    for dat in arr:             
        for idx in range(len(pj.Ant['burst'])): 
            if dat[0:2]== pj.Ant['burst'][idx]['tag']: 
                pj.Ant['burst'][idx]['val'] = dat[2:len(dat)]
                # print("{0}:\t{1}".format(pj.Ant['burst'][idx]['name'], pj.Ant['burst'][idx]['val']))
                break
    
def json_dump(dat):
    import datetime
    x = datetime.datetime.now()
    import json
    file_path = "/home/pi/acu/pkg/acu/slot0/app/py/t1_base/log/"+x.strftime("%y%m%d_%H%M%S")+"_dat.json"
    with open(file_path, 'w') as file:
        json.dump(dat, file)
        
    
def json_rw():
    import io
    import json

    data = {
        "olivia" : {
            "gender": "female",
            "age" : 25,
            "hobby" : ["reading", "music"]
        },
        "Tyler" : {
            "gender": "male",
            "age" : 28,
            "hobby" : ["development", "painting"]
        }
    }

    file_path = "/home/pi/acu/pkg/acu/slot0/app/py/t1_base/conf/test.json"

    with open(file_path, 'w') as file:
        json.dump(data, file)
        
        
    with open(file_path, 'r') as file:
        data = json.load(file)
        
    print(data)
    print(data['Tyler']['age'])
        
    # import os
    # conf_path = os.path.join(os.getcwd(),"conf")
    # conf_path = os.path.join(conf_path,"acu.conf")
    # print(conf_path)
    
    # import json
    # file_path = conf_path
    # with open(file_path, 'r') as file:
        # data = json.load(file)
        
    # print(data)
    

def chk_uart1():
    ser = SerialCommunicator()
    ser.Connect('/dev/ttyUSB5', 57600)

def proc_pcu(arr):

    global ant 
    ant = { 'status':[
        {'name':'Driving', 'tag':"Aa" , "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':'NimAGC', 'tag':"Bc" , "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Driving", 'tag':"Aa", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Static", 'tag':"Ab", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Searching", 'tag':"An", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Tracking", 'tag':"Ao", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"TxMute", 'tag':"As", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"AsiPass", 'tag':"At", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"TrackingStatus", 'tag':"Ad", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"DrivingStatus", 'tag':"Ah", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"DrivingMode", 'tag':"Ai", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"SearchingType", 'tag':"Ae", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"TrackingType", 'tag':"Af", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"ExternalSearchingType", 'tag':"Xh", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"ExternalTrackingType", 'tag':"Xi", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"ExternalLockThreshold", 'tag':"Xj", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"GyroMode", 'tag':"Ar", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"SkewMode", 'tag':"Aj", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"JogMode", 'tag':"Aq", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"TxBand", 'tag':"Au", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"RxBand", 'tag':"Ak", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"TxPolarity", 'tag':"Av", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"RxPolarity", 'tag':"Al", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"TRxPolarity", 'tag':"Am", "val":"", 'type': 0, 'map': ["m1","m2"]},
        # Satelite Information
        {'name':"SatNum", 'tag':"Ba", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"SatLon", 'tag':"Bb", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"SatName", 'tag': "Bl", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"NID", 'tag':"Bm", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Orbital", 'tag':"Bn", "val":"", 'type': 0, 'map': ["m1","m2"]},
        # Tracking Status
        {'name':"NimLock", 'tag':"Ac", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"ModemLock", 'tag':"Xd", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"FunctionCode", 'tag':"Yb", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"ErrorCode", 'tag':"Za", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"PointingError", 'tag':"Xk", "val":"", 'type': 0, 'map': ["m1","m2"]},
        # Device Status
        {'name':"Temperature", 'tag':"Xa", "val":"", 'type': 0, 'map': ["m1","m2"]},
        # Device Status
        {'name':"NimAgc", 'tag':"Bc", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"NimQuality", 'tag':"Bd", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Rssd", 'tag':"Be", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"RssdCn", 'tag':"Bf", "val":"", 'type': 0, 'map': ["m1","m2"]},
        # LookAngle
        # 1. One hand
        {'name':"Azimuth", 'tag':"Cc", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Elevation", 'tag':"Cb", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Relative", 'tag':"Ed", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Skew", 'tag':"Ea", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Heading", 'tag':"Xc", "val":"", 'type': 0, 'map': ["m1","m2"]},
        # 2. Two hands
        # Yaw = Relative, RefAzimuth = Azimuth, RefElevation = Elevation;
        {'name':"Tilt", 'tag':"Eb", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Level", 'tag':"Ec", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"RefBank", 'tag':"Ca", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"AhrsRoll", 'tag':"Da", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"AhrsPitch", 'tag':"Db", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"AhrsYaw", 'tag':"Dc", "val":"", 'type': 0, 'map': ["m1","m2"]},
        # GPS
        {'name':"GpsStatus", 'tag':"Ag", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Latitude", 'tag':"Bg", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"Longitude", 'tag':"Bh", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"GpsSpeed", 'tag':"Bj", "val":"", 'type': 0, 'map': ["m1","m2"]},
        {'name':"GpsTrackAngle", 'tag':"Bk", "val":"", 'type': 0, 'map': ["m1","m2"]},
            ]
       
    }
    
    # import json
    # file_path = "./test.json"
    # with open(file_path, 'r') as file:
        # data = json.load(file)
    import os
    conf_path = os.path.join(os.getcwd(),"conf")
    conf_path = os.path.join(conf_path,"acu.conf")
    print(conf_path)
    
    # import json
    # file_path = conf_path
    # with open(file_path, 'r') as file:
        # data = json.load(file)
        
    # print(data)

    
    for dat in arr: 
        # for obj in ant['status']: 
            # if dat[0:2]== obj['tag']: 
                # obj['val'] = dat[2:len(dat)]
                # # print("{0}:{1}".format(obj['name'],dat[2:len(dat)]))
                
        # for idx in range(len(ant['status'])): 
            # print("{0}:{1}".format(idx, ant['status'][idx]))
        
        # print(dat)
            
        for idx in range(len(ant['status'])): 
            if dat[0:2]== ant['status'][idx]['tag']: 
                ant['status'][idx]['val'] = dat[2:len(dat)]
                # print("{0}:\t{1}".format(ant['status'][idx]['name'], ant['status'][idx]['val']))
                break
        
        
                
    # print(ant)
    # for dat in arr:  
        # if dat[0:2]=="Aa" : print(dat[2:len(dat)])
        # elif dat[0:2]=="Ab" : print(dat[2:len(dat)])
        # elif dat[0:2]=="An" : print(dat[2:len(dat)])
        # elif dat[0:2]=="Ao" : print(dat[2:len(dat)])
        # elif dat[0:2]=="Bc" : print(dat[2:len(dat)])
        # elif dat[0:2]=="Bd" : print(dat[2:len(dat)])
        # elif dat[0:2]=="Be" : print(dat[2:len(dat)])
        # elif dat[0:2]=="Bf" : print(dat[2:len(dat)])
            

    
def chk_uart():
    import serial
    import time
    com = None
    com = serial.Serial('/dev/ttyUSB5', 57600)
    line = b""
    while True:
        if com == None:
            time.sleep(0.1)
        else:
            ch = com.read(1)
            line += ch 
            if ch == b'\n':
                # print(line)
                proc_pcu(line)
    


def t_rstlog():
    import os

    os.system("sudo rm -r /var/log/*.*") 

    dats = ['/var/log/alternatives.log'
    , '/var/log/auth.log'
    , '/var/log/btmp'
    , '/var/log/daemon.log'
    , '/var/log/dpkg.log'
    , '/var/log/kern.log'
    , '/var/log/syslog'
    , '/var/log/lastlog'
    , '/var/log/user.log'
    , '/var/log/wtmp'
    , '/var/log/messages'
    , '/nohup.out'
    , '/home/pi/nohup.out']
    
    for dat in dats:    
        print(dat)
        os.system("sudo su root -c '> {0}'".format(dat)) 
def t_filesize3():
    import os
    import subprocess
    cmd = "sudo find /var/log -xdev -type f -size +2M"
    dat = subprocess.check_output(cmd, shell=True)  # returns the exit code in unix
    # print(dat.decode("utf-8")])
    strings = dat.split()
    print(strings)
    # print(strings[0])
    #dat = os.system("sudo su root -c '> {0}'".format(strings[0])) 
    #cmd = "sudo find /var/log -xdev -type f -size +2M"
    #dat = subprocess.check_output(cmd, shell=True)  # returns the exit code in unix
    

def t_filesize2():
    import subprocess
    cmd = "sudo find /var/log -xdev -type f -size +10M"
    dat = subprocess.call(cmd, shell=True)  # returns the exit code in unix
    print(dat)

def t_filesize1():
    dat = os.system("sudo find /var/log -xdev -type f -size +10M")
    print(dat)

def t_filesize0():
    dir_path = "./"
    f_list = os.listdir(dir_path)

    for f in f_list:    
            print("%s file_name : %s / file_size : %s" %(os.path.isdir(f), f, os.path.getsize(f)) )
    
def t_filepath():
    print("#1 ----------------------------------")
    print(__file__)
    print(os.path.realpath(__file__))
    print(os.path.abspath(__file__))
    print("#2 ----------------------------------")
    print(os.getcwd())
    print(os.path.dirname(os.path.realpath(__file__)) )
    print("#3 ----------------------------------")
    print(os.listdir(os.getcwd()))
    print("#3 ----------------------------------")
    print("before: %s"%os.getcwd())
    #os.chdir("/home/js/test/")
    #print("after: %s"%os.getcwd()) 