	
	var log = [];
	
	var Antenna = {
		/*
			Machine Type (defined 20200625, by hhwang)
			0: MK4 ....
			1: C, K, T, E ....
		*/	
		MachineType:0 ,
		Model:"",
		ModelOption:"" ,
		Version:"" ,
	}
	var Util = {
		DownloadFile: function(content, fileName, contentType) {
			var a = document.createElement("a");
			var file = new Blob([content], {type: contentType});
			a.href = URL.createObjectURL(file);
			a.download = fileName;
			a.click();
		}
	}
	
	var SatInfo = {
		LastSN:0,
		/*
			SN - ChannelNumber
			NM - Name
			LT - Longitude (Position)
			SS - SearchMethod
			TS - TrackMethod
			RP - MechanicalPol
			TR - CoXPol
			TL - AgcThreshold
			SO - SkewOffset
			BL - ZoneLoL
			BH - ZoneLoH
			VT - Polarity
			DS - Modulation
			TF - Freqency
			SR - Symbol
			ND - Network ID
			RF - RollOff
			CL - BucLoFreq
			TP - TxPolarity
			AS - SysSearchMethod
			AT - SysTrackMethod
			AR - SysThresholdLvl
			RA - RssdInputAtten
			BM - BucModel
			TU - TLE_Using
		*/	
		SN: 0,
		NM: "",
		LT: 0,
		SS: 0,
		TS: 0,
		RP: 0,
		TR: 0,
		TL: 0,
		SO: 0,
		BL: 0,
		BH: 0,
		VT: 0,
		DS: 0,
		TF: 0,
		SR: 0,
		ND: 0,
		RF: 0,
		CL: 0,
		TP: 0,
		AS: 0,
		AT: 0,
		AR: 0,
		RA: 0,
		BM: 0,
		TU: 0,
	}

	var Comm = {
		/* protocol for helian
			$CMD,TAG0,TAG1,TAG2,TAG3,.......,CMD_ID*CRC+CR+LF
		*/
		GetVersion: function(){  return this.patch[0].v.toFixed(3); },
		patch:[ 
			{v:0.374,	c:'Separate implementation of manufactoring setting into parameter setting and gain option setting.'},
			{v:0.372,	c:'Refactoring GUI.'},
			{v:0.367,	c:'Fixed Import/Export.'},
			{v:0.360,	c:'Added Import/Export.'},
			{v:0.344,	c:'Added Hidden UI control.'},
			{v:0.342,	c:'Added Burst Processing.'},
			{v:0.340,	c:'Added Log.'},
			{v:0.330,	c:'Added Flash.'},
			{v:0.315,	c:'Added Antenna Information.'},
			{v:0.310,	c:'Added ASI Mute.'},
			{v:0.299,	c:'Added Mode Setting.'},
			{v:0.296,	c:'Added Skew Setting.'},
			{v:0.294,	c:'Added BlockZone.'},
			{v:0.278,	c:'Added Tilt Offset.'},
			{v:0.256,	c:'Added Encoder Reset.'},
			{v:0.252,	c:'Added Trim Offset.'},
			{v:0.251,	c:'Added Cage Offset.'},
			{v:0.246,	c:'Added Axis Setting.'},
			{v:0.245,	c:'Added Ship to bow.'},
			{v:0.244,	c:'Added Gyro mode.'},
			{v:0.239,	c:'Searching Parameter.'},
			{v:0.234,	c:'Added Velocity & Time Setting.'},
			{v:0.230,	c:'Added Offset Setting - 1.'},
			{v:0.220,	c:'Improved protocol.'},
			{v:0.140,	c:'Added Motor functions.'},
			{v:0.128,	c:'Added Release functions.'},
			{v:0.117,	c:'Update Gain functions.'},
			{v:0.105,	c:'Added GetUidToArr function.'},
			{v:0.080,	c:'Added SendWithoutParam function.'},
			{v:0.063,	c:'Added Send function.'},
			{v:0.041,	c:'Added Make function.'},
			{v:0.020,	c:'Added IsValid function.'},
			{v:0.014,	c:'Added AddedCheckSum function.'},
			{v:0.012,	c:'Added CalculateCRC function.'},
			{v:0.001,	c:'New class'}  
			],
		/*Burst*/
		BurstGet: function (){ this.SendWithoutParam("$KR,DAT_S,STS");},
		BurstProc: function (arr){  
			Antenna.MachineType = (parseInt(arr[3], 16)&0x0010)>0?1:
								  (parseInt(arr[3], 16)&0x0020)>0?2:0;
			 
			if(Antenna.MachineType==1) $(".machine_type_0").css("display","block"),$(".machine_type_1").css("display","none"),$(".machine_type_2").css("display","none");
			else if(Antenna.MachineType==2) $(".machine_type_0").css("display","none"),$(".machine_type_1").css("display","block"),$(".machine_type_2").css("display","none");
			else if(Antenna.MachineType==3) $(".machine_type_0").css("display","none"),$(".machine_type_1").css("display","none"),$(".machine_type_2").css("display","block");
		},
		HiddenReset: function (){  
			$(".machine_type_0").css("display","block"),$(".machine_type_1").css("display","block"),$(".machine_type_2").css("display","block");

		},
		/* Gain */
		GainSave: function (){ return this.SendWithoutParam("$KW,DAT_B,FLASH_B");},
		GainReset: function (){ return this.SendWithoutParam("$KW,DAT_B,FREST_B");},
		GainGetOpt1: function (){ return this.SendWithoutParam("$KR,DAT_K,ITN");},
		GainSetOpt1: function (uid){ return this.Send("$KW,DAT_K,ITN",this.GetUidToArr(uid));},
		GainProcOpt1: function (arr, uid, uid_stat, msg){  
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) 
					_(uid[i]).value=parseFloat(arr[i+3]).toFixed(3);
		},
		GainGetOpt2: function (){ return this.SendWithoutParam("$KR,DAT_K,COE");},
		GainSetOpt2: function (uid){ return this.Send("$KW,DAT_K,COE",this.GetUidToArr(uid));},
		GainProcOpt2: function (arr, uid, uid_stat, msg){ 
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(1);
		},
		/* Release */
		Release: function (){ return this.SendWithoutParam("$KW,DAT_K,IFS,FINISH");},
		ReleaseReset: function (){ return this.SendWithoutParam("$KW,DAT_K,IFS,CANCEL");},
		/* Motor */
		MotorOn: function (){ return this.SendWithoutParam("$KW,DAT_M,AN,ON");},
		MotorOff: function (){ return this.SendWithoutParam("$KW,DAT_M,AN,OFF");},
		MotorManual: function (uid){ return this.Send("$KW,DAT_M,TC,ON",this.GetUidToArr(uid));}, 
		MotorZero: function (){ return this.Send("$KW,DAT_M,TC,OFF",[0,0,0,0]);},
		MotorGet: function (){ return this.SendWithoutParam("$KR,DAT_M,MOT_STS");},
		MotorGetProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(1);
		},
		/* Antenna Driving */
		AntennaRun: function (){ return this.SendWithoutParam("$KW,DAT_A,RUN");},
		AntennaHalt: function (){ return this.SendWithoutParam("$KW,DAT_A,HLT");},
		/* Antenna Operating Mode */
		OpmodeDemo: function (){ return this.SendWithoutParam("$KW,DAT_H,DM");},
		/* Offset -1 */
		OffsetGetOpt1: function (){ return this.SendWithoutParam("$KR,DAT_N");},
		OffsetSetOpt1: function (uid){ return this.Send("$KW,DAT_N",this.GetUidToArr(uid));},
		OffsetSetSchDelay: function (uid){ return this.Send("$KW,DAT_N,SCHD",this.GetUidToArr([uid[3]]));},
		OffsetSetOpt1Proc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+2]).toFixed(2);
		},
		/* Velocity & Time */
		VelTimeGet: function (){ return this.SendWithoutParam("$KR,DAT_Q,TGTVA");},
		VelTimeSet: function (uid){ return this.Send("$KW,DAT_Q,TGTVA",this.GetUidToArr(uid));},
		VelTimeProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
		},
		/* Searching Parmeter */
		SpotGet: function (){ return this.SendWithoutParam("$KR,DAT_R,MN");},
		SpotSet: function (uid){ return this.Send("$KW,DAT_R,MN",this.GetUidToArr(uid));},
		SpotProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<3;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
			_('txtSchParamExtra').innerHTML = "Freq(GHz):"+arr[6]+" , "+"Diameter(M)"+arr[7]+" , "+"bWidth(DEG):"+arr[8];
		},
		WideGet: function (){ return this.SendWithoutParam("$KR,DAT_R,AT");},
		WideSet: function (uid){ return this.Send("$KW,DAT_R,AT",this.GetUidToArr(uid));},
		WideProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<3;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
			_('txtSchParamExtra').innerHTML = "Freq(GHz):"+arr[6]+" / "+"Diameter(M)"+arr[7]+" / "+"bWidth(DEG):"+arr[8];
		},
		AftSchEnableGet: function (){ return this.SendWithoutParam("$KR,DAT_R,AF");},
		AftSchEnableSet: function (arr){ return this.SendWithArray("$KW,DAT_R,AF",arr);},
		AftSchEnableProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) {
				AftSchEnable=(arr[3]=='ON')?1:0;
				_(uid[0]).innerHTML=_ABLE[AftSchEnable];
			}
		},
		/* IMU */
		ImuSet: function (){ return this.SendWithoutParam("$KW,DAT_Q,IMUST");},
		ImuReset: function (){ return this.SendWithoutParam("$KW,DAT_Q,IMURS");},	
		/* Skew */
		SkewPeakTrim: function (){ return this.SendWithoutParam("$KW,DAT_E,REL,SF");},	
		/* Axis */
		AxisTrim: function (){ return this.SendWithoutParam("$KW,DAT_H,CM");},
		AxisTrimSet: function (uid){ return this.Send("$KW,DAT_J,CALI",this.GetUidToArr(uid));},
		/* ShipToBow */
		ShipToBowGet: function (){ return this.SendWithoutParam("$KR,DAT_Q,ITSET");},
		ShipToBowSet: function (uid){ return this.Send("$KW,DAT_Q,ITSET",this.GetUidToArr(uid));},
		ShipToBowSetVal: function (val){ return this.Send("$KW,DAT_Q,ITSET",[val,]);},
		ShipToBowProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
		},
		/* Cage Offset */
		CageOffsetGet: function (){ return this.SendWithoutParam("$KR,DAT_Q,CGSET");},
		CageOffsetSet: function (uid){ return this.Send("$KW,DAT_Q,CGSET",this.GetUidToArr(uid));},
		CageOffsetProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
		},
		/* Trim Offset */
		TrimOffsetGet: function (){ return this.SendWithoutParam("$KR,DAT_Q,OTRIM");},
		TrimOffsetSetEle: function (){ return this.SendWithoutParam("$KW,DAT_Q,OTRIM,ELE");},
		TrimOffsetSetAzi: function (){ return this.SendWithoutParam("$KW,DAT_Q,OTRIM,AZI");},
		TrimOffsetSet: function (){ return this.SendWithoutParam("$KW,DAT_Q,OTRIM,ALL");},
		TrimOffsetSetGyroFree: function (){ return this.SendWithoutParam("$KW,DAT_Q,OTRIM,FAL");},
		TrimOffsetProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
		},
		TrimOffsetProc_t: function (arr, uid, uid_stat, msg){
			for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
		},
		/* Encoder Reset */
		EncoderResetSetRelSkew: function (uid){ return this.Send("$KW,DAT_E,REL,SK",this.GetUidToArr([uid[0]]));},
		EncoderResetSetRelTilt: function (uid){ return this.Send("$KW,DAT_E,REL,TI",this.GetUidToArr([uid[1]]));},
		EncoderResetSetRelLevel: function (uid){ return this.Send("$KW,DAT_E,REL,LE",this.GetUidToArr([uid[2]]));},
		EncoderResetSetRelYaw: function (uid){ return this.Send("$KW,DAT_E,REL,YA",this.GetUidToArr([uid[3]]));},
		EncoderResetSetAbsSkew: function (uid){ return this.Send("$KW,DAT_E,ABS,SK",this.GetUidToArr([uid[0]]));},
		EncoderResetSetAbsTilt: function (uid){ return this.Send("$KW,DAT_E,ABS,TI",this.GetUidToArr([uid[1]]));},
		EncoderResetSetAbsLevel: function (uid){ return this.Send("$KW,DAT_E,ABS,LE",this.GetUidToArr([uid[2]]));},
		EncoderResetSetAbsYaw: function (uid){ return this.Send("$KW,DAT_E,ABS,YA",this.GetUidToArr([uid[3]]));},
		EncoderResetGet: function (){ return this.SendWithoutParam("$KR,DAT_E");},
		EncoderResetProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) {
				var tmp = '[ABS] ';
				tmp += "Skew: "+ parseFloat(arr[3]).toFixed(2) +" , ";
				tmp += "Tilt: "+ parseFloat(arr[4]).toFixed(2) +" , ";
				tmp += "Level: "+ parseFloat(arr[5]).toFixed(2) +" , ";
				tmp += "Yaw: "+ parseFloat(arr[6]).toFixed(2);
				_(uid[0]).innerHTML = tmp;
				//for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+2]).toFixed(2);
			}
		},
		/* Tilt Offset */
		TiltOffsetGet: function (){ return this.SendWithoutParam("$KR,DAT_Q,TOSET");},
		TiltOffsetSet: function (uid){ return this.Send("$KW,DAT_Q,TOSET",this.GetUidToArr(uid));},
		TiltOffsetProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
		},
		/* Gyro Mode */
		GyroModeGet: function (){ return this.SendWithoutParam("$KR,DAT_R,GM");},
		GyroModeSet: function (arr){ return this.SendWithArray("$KW,DAT_R,GM",arr);},
		GyroModeProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg))  {
				GyroMode=parseInt(arr[3]);
				_(uid[0]).innerHTML=_GYRO_MODE[GyroMode] + "<i class='caret' style='margin-left:10px'></i>";
			}
		},
		/* BlockZone */
		BlockZoneGet: function (){ return this.SendWithoutParam("$KR,DAT_Y,BLK");},
		BlockZoneSet: function (uid){ return this.Send("$KW,DAT_Y,BLK",this.GetUidToArr(uid));},
		BlockZoneReset: function (){ return this.Send("$KW,DAT_Y,BLK",[0,0,0,0,0,0]);},
		BlockZoneProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(1);
		},
		/* Skew Setting */
		SkewGet: function (){ return this.SendWithoutParam("$KR,DAT_L,ORGN");},
		SkewSetInit: function (){ return this.SendWithoutParam("$KW,DAT_L,INIT");},
		SkewSetZero: function (){ return this.SendWithoutParam("$KW,DAT_L,ZSET");},
		SkewResetZero: function (){ return this.SendWithoutParam("$KW,DAT_L,ZRST");},
		SkewProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) 
				for(var i=0;i<uid.length;i++) _(uid[i]).value=parseFloat(arr[i+3]).toFixed(2);
		},
		/* Powor On Mode */
		PoworOnModeGet: function (){ return this.SendWithoutParam("$KR,DAT_H,IN");},
		PoworOnModeSet: function (arr){ return this.SendWithArray("$KW,DAT_H,IN",arr);},
		PoworOnModeProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg))  {
				for(var i=0; i<_POWER_ON_MODE_T.length;i++){
					if(arr[3]==_POWER_ON_MODE_T[i]) break;
				}
				PoworOnMode=i;
				_(uid[0]).innerHTML=_POWER_ON_MODE[i] + "<i class='caret' style='margin-left:10px'></i>";
			}
		},
		/* TX Mute */
		TxMuteGet: function (){ return this.SendWithoutParam("$KR,DAT_R,TM");},
		TxMuteSet: function (arr){ return this.SendWithArray("$KW,DAT_R,TM",arr);},
		TxMuteProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg))  {
				for(var i=0; i<_ONOFF.length;i++){
					if(arr[3]==_ONOFF[i]) break;
				}
				TxMute=i;
				_(uid[0]).innerHTML=_ABLE[i] + "<i class='caret' style='margin-left:10px'></i>";
			}
		},
		/* ASI Mute */
		AsiMuteGet: function (){ return this.SendWithoutParam("$KR,DAT_R,AM");},
		AsiMuteSet: function (arr){ return this.SendWithArray("$KW,DAT_R,AM",arr);},
		AsiMuteProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg))  {
				for(var i=0; i<_ONOFF.length;i++){
					if(arr[3]==_ONOFF[i]) break;
				}
				AsiMute=i;
				_(uid[0]).value=parseFloat(arr[4]).toFixed(2);
				_(uid[1]).innerHTML=_ABLE[i] + "<i class='caret' style='margin-left:10px'></i>";
			}
		},
		/* Antenna Information */
		AntInfoGet: function (){ return this.SendWithoutParam("$KR,DAT_Y,SER");},
		AntInfoSet: function (uid){ return this.SendText("$KW,DAT_Y,SER",this.GetUidToArr(uid));},
		AntInfoProc: function (arr, uid, uid_stat, msg){
			if(this.CheckRecv(arr,uid_stat,msg)) {
				try{
					for(var i=0;i<uid.length;i++) _(uid[i]).value=arr[i+3];
				}catch(error){
				}
				Antenna.Model=arr[4];
				Antenna.ModelOption=arr[5];
				Antenna.Version=arr[6];
			}
		},
		/* Flash */
		FlashSave: function (){ return this.SendWithoutParam("$KW,DAT_B,FLASH_A");},
		FlashReset: function (){ return this.SendWithoutParam("$KW,DAT_B,FREST_A");},
		/* Satellite Setting */
		SiGet: function (){ return this.SendWithoutParam("$KR,DAT_O");},  
		SiIdSet: function (id){ return this.SendWithoutParam("$KW,DAT_O,SN:"+id);}, 
		/* 1. Searching Source */
		SiSearchingSourceSet: function (id){ return this.SendWithoutParam("$KW,DAT_O,SS:"+id);}, 
		SiUpdateAll:function(params){
			for(var i=2;i<params.length;i++){
				var spar = params[i].split(':')
				if(spar.length==2){
					//console.log(spar[0]+": "+spar[1])
					if(spar[0]=="SN") SatInfo.SN = parseInt(spar[1]);
					else if(spar[0]=="NM") SatInfo.NM = spar[1];
					else if(spar[0]=="LT") SatInfo.LT = parseFloat(spar[1]);
					else if(spar[0]=="SS") SatInfo.SS = parseInt(spar[1]);
					else if(spar[0]=="TS") SatInfo.TS = parseInt(spar[1]);
					else if(spar[0]=="RP") SatInfo.RP = parseInt(spar[1]);
					else if(spar[0]=="TR") SatInfo.TR = parseInt(spar[1]);
					else if(spar[0]=="TL") SatInfo.TL = parseInt(spar[1]);
					else if(spar[0]=="SO") SatInfo.SO = parseFloat(spar[1]);
					else if(spar[0]=="BL") SatInfo.BL = parseInt(spar[1]);
					else if(spar[0]=="BH") SatInfo.BH = parseInt(spar[1]);
					else if(spar[0]=="VT") SatInfo.VT = parseInt(spar[1]);
					else if(spar[0]=="DS") SatInfo.DS = parseInt(spar[1]);
					else if(spar[0]=="TF") SatInfo.TF = parseInt(spar[1]);
					else if(spar[0]=="SR") SatInfo.SR = parseInt(spar[1]);
					else if(spar[0]=="ND") SatInfo.ND = parseInt(spar[1]);
					else if(spar[0]=="RF") SatInfo.RF = parseFloat(spar[1]);
					else if(spar[0]=="CL") SatInfo.CL = parseInt(spar[1]);
					else if(spar[0]=="TP") SatInfo.TP = parseInt(spar[1]);
					else if(spar[0]=="AS") SatInfo.AS = parseInt(spar[1]);
					else if(spar[0]=="AT") SatInfo.AT = parseInt(spar[1]);
					else if(spar[0]=="AR") SatInfo.AR = parseInt(spar[1]);
					else if(spar[0]=="RA") SatInfo.RA = parseInt(spar[1]);
					else if(spar[0]=="BM") SatInfo.BM = parseInt(spar[1]);
					else if(spar[0]=="TU") SatInfo.TU = parseInt(spar[1]);
				} 
			}
		},
	
		
		/* Sync data */
		sync_ready:false,
		sync_idx:0,
		SyncManufacturingSetting: function (){
	
			var init = setInterval(function(){
					
				switch(Comm.sync_idx++){
					case 0: {
						Comm.sync_ready = false;
						_noti(0,"Start sync of 'Manufacturing Settings'' ."); 
						Comm.BurstGet(); 
						_('CommProgress').hidden=false;	
					}break;
					case 1: Comm.GainGetOpt1(); break;
					case 2: Comm.GainGetOpt2(); break;
					case 3: Comm.OffsetGetOpt1(); break;
					case 4: Comm.VelTimeGet(); break;
					case 5: Comm.SpotGet(); break;
					case 6: Comm.WideGet(); break;
					case 7: Comm.AsiMuteGet(); break;
					case 8: Comm.ShipToBowGet(); break;
					case 9: Comm.CageOffsetGet(); break;
					case 10: Comm.TrimOffsetGet();break;
					case 11: Comm.EncoderResetGet(); break;
					case 12: Comm.AntInfoGet(); break;
					case 13: Comm.GyroModeGet(); break;
					case 14: Comm.BlockZoneGet(); break;
					case 15: Comm.SkewGet(); break;
					case 16: Comm.PoworOnModeGet(); break;
					case 17: Comm.TxMuteGet(); break;
					/* case 7: Comm.AftSchEnableGet();  break; */
					/* case 12: Comm.TiltOffsetGet();  break; */
					default : {
						Comm.sync_idx=0;
						Comm.sync_ready = true;
						_noti(0,"Synced 'Manufacturing Settings'."); 
						_('CommProgress').hidden=true;	
						clearInterval(init);
					}
				}	
				_('CommProgress').value=Math.round(Comm.sync_idx);	
				
			}, 200);	
		
		},
		
		
		SyncParameterSetting: function (){
	
			var init = setInterval(function(){
					
				switch(Comm.sync_idx++){
					case 0: {
						Comm.sync_ready = false;
						_noti(0,"Start sync of 'Parameter Settings'' ."); 
						Comm.BurstGet(); 
						_('CommProgress').hidden=false;	
					}break;
					case 1: Comm.PoworOnModeGet(); break;
					case 2: Comm.TxMuteGet(); break;
					case 3: Comm.OffsetGetOpt1(); break;
					case 4: Comm.VelTimeGet(); break;
					case 5: Comm.SpotGet(); break;
					case 6: Comm.WideGet(); break;
					case 7: Comm.AsiMuteGet(); break;
					case 8: Comm.ShipToBowGet(); break;
					case 9: Comm.CageOffsetGet(); break;
					case 10: Comm.TrimOffsetGet();break;
					case 11: Comm.EncoderResetGet(); break;
					case 12: Comm.AntInfoGet();  break;
					case 13: Comm.GyroModeGet(); break;
					case 14: Comm.BlockZoneGet(); break;
					case 15: Comm.SkewGet(); break;
					/* case 16: Comm.PoworOnModeGet(); break;	 */
					/* case 17: Comm.TxMuteGet(); break;         */
					/* case 1: Comm.GainGetOpt1(); break;        */
					/* case 2: Comm.GainGetOpt2(); break;        */
					/* case 7: Comm.AftSchEnableGet();  break; 	 */
					/* case 12: Comm.TiltOffsetGet();  break; 	 */
					default : {
						Comm.sync_idx=0;
						Comm.sync_ready = true;
						_noti(0,"Synced 'Parameter Settings'."); 
						_('CommProgress').hidden=true;	
						clearInterval(init);
					}
				}	
				_('CommProgress').value=Math.round(Comm.sync_idx);	
				
			}, 200);	
		
		},
		
		SyncGainOffsetSetting: function (){
	
			var init = setInterval(function(){
					
				switch(Comm.sync_idx++){
					case 0: {
						Comm.sync_ready = false;
						_noti(0,"Start sync of 'GainOffset Settings'' ."); 
						Comm.BurstGet(); 
						_('CommProgress').hidden=false;	
					}break;
					case 1: Comm.GainGetOpt1(); break;
					case 2: Comm.GainGetOpt2(); break;
					case 3: Comm.AntInfoGet(); break;
					/* case 3: Comm.OffsetGetOpt1();  break;	*/
					/* case 4: Comm.VelTimeGet();  break;       */
					/* case 5: Comm.SpotGet();  break;          */
					/* case 6: Comm.WideGet();  break;          */
					/* case 7: Comm.AftSchEnableGet();  break;  */
					/* case 8: Comm.ShipToBowGet();  break;     */
					/* case 9: Comm.CageOffsetGet();  break;    */
					/* case 10: Comm.TrimOffsetGet(); break;    */
					/* case 11: Comm.EncoderResetGet(); break;  */
					/* case 12: Comm.TiltOffsetGet(); break;    */
					/* case 13: Comm.GyroModeGet();  break;     */
					/* case 14: Comm.BlockZoneGet();  break;    */
					/* case 15: Comm.SkewGet();  break;         */
					/* case 16: Comm.PoworOnModeGet();  break;  */
					/* case 17: Comm.TxMuteGet();  break;       */
					/* case 18: Comm.AsiMuteGet();  break;      */
					/* case 19: Comm.AntInfoGet();  break;      */
					default : {
						Comm.sync_idx=0;
						Comm.sync_ready = true;
						_noti(0,"Synced 'GainOffset Settings'."); 
						_('CommProgress').hidden=true;	
						clearInterval(init);
					}
				}	
				_('CommProgress').value=Math.round(Comm.sync_idx*4);	
				
			}, 200);	
		
		},
		
		/* Core -------------------------------------------------------------------------------- */
		temp: function() {}, 
		CheckProc: function (arr, msg){ 
			this.CheckRecvWithoutStat(arr,msg);
		},
		CheckRecv: function(arr,uid_stat,msg){ 
		
			if(arr[0]=='$KF'){
				var msg="Timeout error '"+msg+"'."; 
				//if(this.sync_ready) _status(uid_stat,msg),_noti(2,msg); 
				if(this.sync_ready) _noti(2,msg); 
				return -2;
			}else if(arr[0]=='$KA'){
				var msg="Set the '"+msg+"'."; 
				//if(this.sync_ready) _status(uid_stat,msg),_noti(0,msg); 
				if(this.sync_ready) _noti(0,msg); 
				return 1;
			}else if(arr[0]=='$KR'){
				var msg="Get the '"+msg+"'."; 
				//if(this.sync_ready) _status(uid_stat,msg),_noti(0,msg); 
				if(this.sync_ready) _noti(0,msg); 
				return 1;
			}
		},
		CheckRecvWithoutStat: function(arr,msg){ 
			if(arr[0]=='$KF'){
				var msg="Timeout error '"+msg+"'."; 
				_noti(2,msg); 
				return -2;
			}else if(arr[0]=='$KA'){
				var msg="Set the '"+msg+"'."; 
				_noti(0,msg); 
				return 1;
			}else if(arr[0]=='$KR'){
				var msg="Get the '"+msg+"'."; 
				//_noti(0,msg); 
				return 1;
			}
		},
		CheckRecvLength: function(arr){ 
			if(arr.length < 3){
				var msg="Communication error (No response)."; 
				if(this.sync_ready) _noti(2,msg); 
				return -1;
			}
		},
		CalculateCRC: function(dat){
			var len = dat.length;
			var crc = 0;
			for(var i=0; i<len; i++){  
				crc = 0xffff&(crc >> 8) | 0xffff&(crc << 8);
				crc ^= dat[i].charCodeAt(0);
				crc ^= 0xffff&((crc & 0xff) >> 4);
				crc ^= 0xffff&(crc << 12);
				crc ^= 0xffff&((crc & 0x00ff) << 5);
				//console.log(i+" - "+crc+" / "+dat[i].charCodeAt(0)+" / "+len);
			}			
			return crc.toString(16).toUpperCase(); 
		},
		AddedCheckSum: function (dat){
			/*added cmd idx*/
			this.cmd_idx++;
			this.cmd_idx = this.cmd_idx>9?2:this.cmd_idx;	 
			dat += ("," + this.cmd_idx);	
			/*added crc*/	
			var crc = this.CalculateCRC(dat);
			dat += ("*" + crc + "\r\n");
			//console.log(dat);
			return dat;
		},
		MakeText: function (cmd, param){
			var tmp = cmd;
			for(var i=0;i<param.length;i++) tmp+=(","+param[i]);
			return this.AddedCheckSum(tmp);
		},
		Make: function (cmd, param){
			var tmp = cmd;
			for(var i=0;i<param.length;i++) tmp+=(","+parseFloat(param[i]).toFixed(3));
			return this.AddedCheckSum(tmp);
		},
		IsValid: function (dat){	/* idx == 6, include '\r' & '\n' */
			var len = dat.length;
			var hex = [,];
			var substr = dat.substring(0, len-7);
			var crc0 = dat.substring((len-6), len-2);
			var crc1 = this.CalculateCRC(substr);
			return crc0==crc1?true:false;
		},
		SendWithoutParam: function (cmd){
			
			var tmp = this.AddedCheckSum(cmd);
			return this.transfer(tmp);
		},
		SendWithArray: function (cmd, arr){
			for(var i=0;i<arr.length;i++) cmd+=(","+arr[i]);
			var tmp = this.AddedCheckSum(cmd); 
			
			return this.transfer(tmp);
		},
		SendText: function (cmd, arr){
			
			var tmp = this.MakeText(cmd, arr);
			
			return this.transfer(tmp);
		},
		Send: function (cmd, arr){
			
			var tmp = this.Make(cmd, arr);
			
			return this.transfer(tmp);
		},
		transfer: function (cmd){
			
			if(this.exp_flag){
				return cmd;
			}
			
			this.AddTxLog(cmd);
			this.AddTxFLog(cmd);
			
			//onsole.log(cmd);
			
			//** NTT *** req += ","+guid()+","; //Exception for IE.(IE11)	
			var xhp = new XMLHttpRequest();  
			xhp.responseText = "";
			xhp.addEventListener("error", this.transferFailed);
			xhp.onreadystatechange = function() {  
			if (this.readyState == 4 && this.status == 200) { ProcRecv(this.responseText);}};
			xhp.open("GET", "../assets/php/request.php?req="+cmd, true);
			xhp.send();
			
			return "";
		},
		transferFailed: function (evt){
			console.log(transferFailed)
		},
		GetUidToArr: function(uid){
			var arr = [];
			for(var i=0;i<uid.length;i++) arr[i] = _(uid[i]).value;
			return arr;
		},
		ShowPatch: function (){
			if($('.patch-list').html()!=""){
				$('.patch-list').html("")
				$('.patch-list').hide()
				return; 
			}

			$('.patch-list').show()
			var txt = "";
			txt += "<ul>";
			for(i=0;i<this.patch.length;i++){
				txt += "<li>";
				txt += '<div style="float:left;">['+this.patch[i].v.toFixed(3) + ']</div>';
				txt += '<div style="padding-left:60px;">'+this.patch[i].c+'</div>';
				txt += "</li>";
			}
			$('.patch-list').html(txt);
		},
		/* Export */
		exp:[],
		exp_flag:false,
		DoExportStart: function (){
			this.exp_flag = true;
		},
		DoExportEnd: function (){
			this.exp_flag = false;
		},
		/* LOG */
		log_flag:0,
		log:[],
		cmd_idx:2, 
		ShowLog: function (){
			if(this.log_flag) this.log_flag=0,_('log').hidden = true;
			else this.log_flag=1,_('log').hidden = false;
		},AddRxLog: function (msg){
			this.AddLog(0, msg);
		},AddTxLog: function (msg){
			this.AddLog(1, msg);
		},AddLog: function (direct, msg){
			this.log.push({dir:direct, time:(new Date().toISOString()), dat:msg}); 
			if(this.log.length>100) this.log.shift();
			_('log').innerHTML="";
			for(var i=this.log.length-1;i>=0;i--)
				//_('log').innerHTML += ('['+this.log[i].time+'] '+ (this.log[i].dir==0?'-> ':'<- ') +this.log[i].dat + '<br>');
				if(this.log[i].dir==0) _('log').innerHTML += ('<font style="color:#b16464"> &#62; ['+this.log[i].time+'] ' +this.log[i].dat + '</font><br>');
				else _('log').innerHTML += ('<font style="color:#646eb1"> &#60; ['+this.log[i].time+'] ' +this.log[i].dat + '</font><br>');
		},
		/* Filtered LOG */
		flog_flag:0,
		flog:[],
		ShowFLog: function (){
			try{
				if(this.flog_flag) this.flog_flag=0,_('flog').hidden = true;
				else this.flog_flag=1,_('flog').hidden = false;
			}catch(error){ }
		},AddRxFLog: function (msg){
			this.AddFLog(0, msg);
		},AddTxFLog: function (msg){
			this.AddFLog(1, msg);
		},AddFLog: function (direct, msg){
			try{
				this.flog.push({dir:direct, time:(new Date().toISOString()), dat:msg}); 
				if(this.flog.length>10) this.flog.shift();
				_('flog').innerHTML="";
				for(var i=this.flog.length-1;i>=0;i--)
					if(this.flog[i].dir==0) _('flog').innerHTML += ('<font style="color:#b16464"> &#62; ['+this.flog[i].time+'] ' +this.flog[i].dat + '</font><br>');
					else _('flog').innerHTML += ('<font style="color:#646eb1"> &#60; ['+this.flog[i].time+'] ' +this.flog[i].dat + '</font><br>');	
			}catch(error){ }
		}
	}