// 20200404~08	based for status 
// 20200409		resorting items (devices, io, network), trimed Display of major. 
/* data type ----------------------------------- */
/* XXXXXXX0:none 		*/ 
/* XXXXXXX1:direct 		*/
/* XXXXXXX2:list 		*/
/* data output format -------------------------- */
/* XXXXXXX3:map 		*/ 
/* XXXXXX0X:none 		*/ 
/* XXXXXX1X:degree 		*/
/* XXXXXX2X:			*/
/* XXXXXX3X:	 		*/
/* content source of card title  --------------- */
/* XXXX0XXX:default	 	*/
/* XXXX1XXX:rename 		*/
/* XXXX2XXX:reserved	*/
/* XXXX3XXX:reserved 	*/
/* antenna model type  ------------------------- */
/* 0XXXXXXX:public  	*/
/* 1XXXXXXX:mk4 series 	*/
/* 2XXXXXXX:C series 	*/
/* setting option   ------------------------- */
/* XXX0XXXX:  	*/
/* XXX1XXXX: 	*/
/* XXX2XXXX: 	*/ 
/* XXX3XXXX: 	*/ 
/* XXX4XXXX: 	*/ 
/* XXX5XXXX: 	*/ 

var Antenna = {
	Dashboard:{ 
		Link:{
			IsConnected:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["Off","On"],Name:"Connection", Display:0}, 
			ModelType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000003,Map:[{Key:0x00,Dat:"Unknown"}, {Key:0x10,Dat:"MK4 Series"},{Key:0x20,Dat:"C Series"}], Display:0},
			ModelName:{Dat:'Unknown',oDat:'Unknown',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Step:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000}, StepString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Step", Display:0},
			CompassMode:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000}, CompassModeString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Compass Mode", Display:0},
		},
		Operating:{
			Driving:{
				OnOff:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x000A1002,List:["Off","On"],Name:"Driving On/Off", Display:0}, 
				Gps:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["Unknown", "Not Valid", "Valid"],Name:"GPS Status", Display:0},
				Gyro:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["Not Valid", "Valid"],Name:"Gyro Status", Display:0},
			},
			Initialize:{
				Compass:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000, Display:0}, CompassString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Compass Mode", Display:0},
			},
			Searching:{
				Operating:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000, Display:0}, OperatingString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Searching Mode", Display:0}, 
				Skew:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000, Display:0}, SkewString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Skew Mode", Display:0}, 
				Reference:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000, Display:0}, ReferenceString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Searching Reference", Display:0}, 
				RefThreshold:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001000, Name:"Searching Threshold", Display:0},
			},
			Tracking:{
				Reference:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000, Display:0}, ReferenceString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Tracking Reference", Display:0}, 
				DecTxLoFreq:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002, List:["None","Detected"],Name:"DecTxLoFreq", Display:0},
			},
		},
		Signal:{
			NimAGC:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"NIM AGC", Display:0},
			NimQuality:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"NIM Quality", Display:0}, 
			Rssd:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"RSSD", Display:0},
			RssdCn:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"RSSD C/N", Display:0},
		},
		LookAngle:{
			/* MK4 Series */
			Elevation:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x10000011, Display:0},
			Azimuth:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x10000011, Display:0},
			Relative:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x10000011, Display:0},
			/* C Series */
			RefBank:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:0},
			RefElevation:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:1},
			RefAzimuth:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:1},
			Tilt:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:0},
			Level:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:0},  
			Yaw:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:0},
			AhrsRoll:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:1},
			AhrsPitch:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:1},
			AhrsYaw:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x20000011, Display:1},
		},
		Target:{
			ID:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Name:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Position:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			TransportFrequency:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000, Display:1},
			TransportSymbolRate:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000, Display:1},
			RxBand:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000010, Display:0}, RxBandString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"RxBand", Display:0},
			RxPolarity:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000010, Display:0}, RxPolarityString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"RxPolarity", Display:0},
			TxBand:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000010, Display:1}, TxBandString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"TxBand", Display:1},
			TxPolarity:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000010, Display:1}, TxPolarityString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"TxPolarity", Display:1},
			TRxPolarity:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000010, Display:1}, TRxPolarityString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"TRxPolarity", Display:1},
			SearchingType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["DVB ACG Threshold", "DVB C/N Threshold", "DVB Carrier Lock", "RSSD Threshold", "RSSD C/N Threshold", "External Lock"], Display:1}, 
			SearchingTypeString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"SearchingType", Display:0},
			TrackingType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["DVB ACG Level", "DVB C/N Ratio", "RSSD AGC Level", "RSSD C/N Ratio"], Display:1}, 
			TrackingTypeString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"TrackingType", Display:1}, 
		
		},
	},
	SatelliteChannel:{
		Zone:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
		ID:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
		Name:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:0},
		Position:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110011, Display:0},
		TransportFrequency:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
		TransportSymbolRate:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
		RxBand:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["C-Band", "X-Band", "KU-Band", "KA-Band"], Display:0}, 
		RxBandString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"RxBand", Display:0},
		RxPolarity:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["Horizontal", "Vertical", "LHCP", "RHCP"], Display:0}, 
		RxPolarityString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"RxPolarity", Display:0},
		TxBand:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["C-Band", "X-Band", "KU-Band", "KA-Band"], Display:1}, 
		TxBandString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"TxBand", Display:1},
		TxPolarity:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["Horizontal", "Vertical", "LHCP", "RHCP", "Follow TX-RX Pol"], Display:1}, 
		TxPolarityString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"TxPolarity", Display:1},
		TRxPolarity:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["Cross Pol", "Co Pol"], Display:1}, 
		TRxPolarityString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"TRxPolarity", Display:1},
		SearchingType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["DVB ACG Threshold", "DVB C/N Threshold", "DVB Carrier Lock", "RSSD Threshold", "RSSD C/N Threshold", "External Lock"], Display:1}, 
		SearchingTypeString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"SearchingType", Display:0},
		TrackingType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:["DVB ACG Level", "DVB C/N Ratio", "RSSD AGC Level", "RSSD C/N Ratio"], Display:1}, 
		TrackingTypeString:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00011001,Name:"TrackingType", Display:1}, 
		VT:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002, List:['LL (18V 0KHz)','LH (18V 22KHz)','RL (13V 0KHz)','RH (13V 22KHz)','HH (18V 22KHz)','VL (13V 22KHz)','HL (18V 0KHz)','VL (13V 0KHz)'], Display:1}, 
		Threshold:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
		SkewTrimmingAngle:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110011, Display:1},
		BucLoFrequency:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
		LnbLowLoFrequency:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
		LnbHighLoFrequency:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
		LnbBandSelection:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00210002, List:["Auto", "DVB S1", "DVB S2", "DSS"], Display:1},
		NID:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
		RollOff:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110011, Display:1},
		Option:{Name:"Satellite Channel",dType:0, Next:false, Action:[
			{Name:'Reload',Cmd:{ID:10,Val:[]}},
			{Name:'Update',Cmd:{ID:11,Val:[]}},
			{Name:'Apply',Cmd:{ID:12,Val:[]}},
			]},
	},
	Interworking:{ 
		Gps:{
			UseSrc:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00201002,List:["Internal","External","Manual"],Name:"Source", Display:0}, /* Manual, Internal, External */		
			Status:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000002,List:["None","Received","Manual"], Display:0},
			IsValids:{
				Internal:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000002,List:["None","Received"], Display:1},
				External:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000002,List:["None","Received"], Display:1},
			},
			Values:{
				IntLatitude:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:0},
				IntLongitude:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:0},
				IntSpeed:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011,Name:"Speed", Display:0},
				IntTrackAngle:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011,Name:"Track Angle", Display:0},
				ExtLatitude:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:0},
				ExtLongitude:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:0}, 
				ManualLatitude:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00100011, Display:0},
				ManualLongitude:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00100011, Display:0},
				UseLatitude:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001010,Name:"Latitude", Display:0},
				UseLongitude:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001010,Name:"Longitude", Display:0},
			},	
			GpsOutFormat:{
				Symbol:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["GP","GN"], Display:0},
				Type:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["RMC","GLL","GGA"], Display:0},
				Option:{Name:"GPS Output Format",dType:0},
			},
			Interface:{
				BaudRate:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["1200","2400","4800","9600","19200","38400","57600","115200"], Display:0},
				Option:{Name:"Interface",dType:0},
			},
			Option:{Name:"GPS",dType:0},
		},
		Gyro:{
			UseSrc:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["External","Manual"], Display:1}, /* Manual, External */
			Status:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000002,List:["None","Received","Manual"], Display:0},		
			IsValids:{
				Nmea2000:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["None","Received"], Name:'NMEA2000', Display:1},
				Nmea0183:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["None","Received"], Name:'NMEA0183', Display:1},
				SyncStep:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["None","Received"], Name:'Sync&amp;Step ', Display:1},
			},
			Values:{
				Use:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Name:'Heading', Display:0},
				Manual:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000010, Display:1},
				_Nmea2000:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
				_Nmea0183:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
				_SyncStep:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1}, 
			},
			Setting:{
				UseNMEA2000Gui:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00201002,List:["None","Used"],Name:"Use NMEA2000 UI", Display:1}, /* ExtOpt - 0 */
				Type:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00201012, List:["NMEA0183","Synchro 360:1","Synchro 180:1","Synchro 90:1","Synchro 36:1","Synchro 1:1", "Step by Step 360:1", "Step by Step 180:1","Step by Step  90:1","NMEA2000"],Name:"Use Type", Display:0},
			},
			Interface:{
				BaudRate:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["1200","2400","4800","9600","19200","38400","57600","115200"], Display:1},
				Direction:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["Normal","Reverse"], Display:1},
				SyncFreq:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["50/60Hz","400/500Hz"], Display:1},
				Converter:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00100011, Display:0},
			},
			Option:{Name:"GYRO",dType:0},
		},
		Console:{
			IsUse:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["Disable","Enable"], Display:0},
			LockTTL:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["TTL0","TTL1"], Display:0},
			GpsOutFormat:{
				Symbol:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["GP","GN"], Display:0},
				Type:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["RMC","GLL","GGA"], Display:0},
				Option:{Name:"GPS Output Format",dType:0},
			},
			Interface:{
				BaudRate:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["1200","2400","4800","9600","19200","38400","57600","115200"], Display:0},
			},
		},
		ABS:{
			IsConnected:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["Off","On"],Name:"Connection", Display:0},
			RcvCnt:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001, Display:0, Name:"Received SatInfo"},
			IsUse:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x002A0002,List:["Disable","Enable"], Display:0},
			ModemClass:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00210002,List:["iDirect","ComROAM","STM VACP"], Display:0},
			ProtocolType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00210000,List:["iDirect","ComROAM","STM VACP"], Display:0},
			ExtLockSrc:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00210002,List:["Console","Ethernet"], Display:0},
			LnbBand1Lo:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
			LnbBand2Lo:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
			LnbBand3Lo:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
			LnbBand4Lo:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
			RollOff:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110011, Display:1},
			RfTermType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:1},
			Interface:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x0001002,List:["TCP/IP"],Name:"Interface", Display:0},
			Port:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Option:{Name:"ABS",dType:0},
		},
		Vcs:{
			IsUse:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000,List:["Disable","Enable"], Display:0},
			IsConnected:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["Off","On"],Name:"Connection", Display:0},
			Interface:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["TCP/IP"],Name:"Interface", Display:0},
			Port:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			RecvCnt:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Recv Cnt", Display:0}, /* Number of recvieved satellite information. */
			Option:{Name:"VCS",Desc:{Use:false,Dat:"TCP/IP Communication for dual antenna."},dType:0},
		},
		Mnc:{
			IsUse:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000,List:["Disable","Enable"], Display:0},
			IsConnected:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["Off","On"],Name:"Connection", Display:0},
			Interface:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["TCP/IP"],Name:"Interface", Display:0},
			Port:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Option:{Name:"M&C",Desc:{Use:false,Dat:"TCP/IP Communication for remote application."},dType:0},
			
		},
		Ttp:{
			IsUse:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000,List:["Disable","Enable"], Display:0},
			IsConnected:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["Off","On"],Name:"Connection", Display:0},
			Interface:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["TCP/IP"],Name:"Interface", Display:0},
			Port:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Option:{Name:"TTP",Desc:{Use:false,Dat:"TCP/IP Communication for old CLI protocol(support status messgae only)."},dType:0},
		},
		Option:{Name:"Interworking",dType:0, Next:true},
	},
	Install:{
		SearchingMethod:{ 
			MethodType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["Standby", "Manual Point", "Manual Search", "Auto Search", "Axis Ctrl", "Demonstration", "Axis Calibration"], Display:0},
			TypeString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001000,Name:"Searching Mode", Display:0},
			/* Manual Point, Manual Searching only*/
			Elevation:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00010011, Display:0},
			Azimuth:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00010011, Display:0},		
			Static:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x002A0002,List:["Off","On"], Display:0},
			Searching:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x002A0002,List:["Off","On"], Display:0},
			Tracking:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x002A0002,List:["Off","On"], Display:0},
			Jog:{
				Mode:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["Stop","Up","Down","Right","Left","Mute"], Display:0},
				Option:{Name:"Jog Controller",dType:0},	
			},
			Asi:{
				Pass:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["Off","On"], Display:0},
				MuteOnOff:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00200002,List:["Off","On"], Display:0},
				MuteThreshold:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00100001, Display:0},
				Option:{Name:"ASI",dType:0},
			},
			Option:{Name:"Searching & Tracking",Desc:{Use:false,Dat:"Display searcing method and pointing information."},dType:0},
		},
		SkewMethod:{ 
			MethodType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00100001, Display:0}, TypeString:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00001001,Name:"Skew Mode", Display:0},
			/* Manual only*/
			Angle:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00100011, Display:0},	
			Option:{Name:"Skew",Desc:{Use:false,Dat:"Display skew method information."},dType:0},	
		},
		AcuNetwork:{
			Ip0v4:{
				Addr:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00010001, Display:1},
				Sn:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00010001, Display:1},
				Gw:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00010001, Display:1},
			},
			Ip1v4:{
				Addr:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00010001, Display:0},
				Sn:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00010001, Display:0},
				Gw:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00010001, Display:0},
				Option:{Name:"ETH1 IPv4",dType:0},
			},
			Port:{
				Mnc:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:0},
				Abs:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:0},
				Ttp:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:0},
				Vcs:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00110001, Display:0},
			},
			Mac:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			ExtNetDev:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000002,List:["WIFI USB Dongle","USB LAN Card"], Display:0},
			Option:{Name:"Network",dType:0},
		},
		Option:{Name:"Install",dType:0, Next:true},
	},
	Device:{
		Pcu:{
			Sn:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			FuncCode:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			ErrCode:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Temperature:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000011, Display:0},
			Version:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Volt:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
			Current:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
			ActivedSlot:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
			Option:{Name:"PCU ",dType:0},
		},
		Acu:{
			Sn:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Pn:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			ErrCode:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Temperature:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000011, Display:0},
			Version:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Volt:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
			Current:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
			ActivedSlot:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000002,List:["Slot0","Slot1","Slot2","Slot3"], Display:1},
			IO:{
				Sw0:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["ACU","VCS"], Name:"Switch 1 (Deivce)", Display:0},
				Sw1:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["English","Russian"], Name:"Switch 2 (Language)", Display:0},
				Sw2:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["-","-"], Name:"Switch 3 (Reserved)", Display:0},
				Sw3:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["All-in-one","Module"], Display:0, Name:"Switch 4 (BDMUX)"},
				FrontType:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000002,List:["LED Type","Text LCD+Keys"], Display:0},
				Emc0:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["On","Off"], Name:"EMC CH0", Display:0},
				Emc1:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["On","Off"], Name:"EMC CH1", Display:0},
				Emc2:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["On","Off"], Name:"EMC CH2", Display:0},
				Emc3:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000000,List:["On","Off"], Name:"EMC CH3", Display:0},
				EmcSw:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["On","Off"], Name:"EMC SW", Display:0},
				DecRef:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000002,List:["None","Detected"], Display:0}, 
				Option:{Name:"In/Out Port",dType:0},  
			},
			Option:{Name:"ACU ",dType:0},
		},
		Buc:{
			Sn:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Pn:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			OutPower:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			Temperature:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
			Volt:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
			Attn:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000011, Display:1},
			TxOn:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			Fan:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			PllLock:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			Mute:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			IsOverTemperature:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			IsOverPower:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			IsDataIn:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00001002,List:["None", "Linked"], Name:'Communication', Display:1},
			Model:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000003,Map:[{Key:0x00,Dat:"Unknown"}, {Key:1,Dat:"Revgo Type1"},{Key:2,Dat:"Revgo Type2"},{Key:10,Dat:"NJRC Type1"},{Key:20,Dat:"XMW Type1"}], Display:0},
			Version:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:1},
			Option:{Name:"BUC",dType:1},
		},
		Lnb:{
			Sn:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Version:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Option:{Name:"LNB ",dType:0},
		},
		BdMux:{
			TxMuteSwitch:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Ref10MHzSwitch:{Dat:0, oDat:0,Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Version:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			Option:{Name:"BDMUX",dType:0},
		},
		Option:{Name:"Devices",dType:0, Next:true},
	},
	AcuFunc:{	
		Exceptions:{
			PcuDfu:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0}, /* ExtOpt - 1 */
			PcuConn:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0}, /* ExtOpt - 2 */
			AutoGain:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0}, /* ExtOpt - 4 */
		},
		Notification:{
			Moisture:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0}, /* Noti - 0 */
		},
		Pub:{
			SupprtModel:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			UseTleUI:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			LanguageType:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			BucPwrSync:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
			IsUpdatePcu:{Dat:'', oDat:'',Timeout:{ TM:0, FF:true},dType:0x00000001, Display:0},
		},
		Option:{Name:"ACU Functions",dType:0},
	},
}
var AntFunc = {	
	UpdateFromArray : function(arr) {
 
		Antenna.Dashboard.Link.IsConnected.Dat= (arr[0]);
		Antenna.Dashboard.Link.ModelType.Dat = (arr[1]);
		Antenna.Dashboard.Link.ModelName.Dat = (arr[2]);
		Antenna.Dashboard.Link.Step.Dat = (arr[3]);
		Antenna.Dashboard.Link.StepString.Dat = (arr[4]);
		Antenna.Dashboard.Link.CompassMode.Dat = (arr[5]);
		Antenna.Dashboard.Link.CompassModeString.Dat = (arr[6]);

		Antenna.Install.SearchingMethod.MethodType.Dat = (arr[60]);
		Antenna.Install.SearchingMethod.TypeString.Dat = (arr[61]);
		Antenna.Install.SearchingMethod.Elevation.Dat = parseFloat(arr[40]);
		Antenna.Install.SearchingMethod.Azimuth.Dat = parseFloat(arr[41]);
		Antenna.Install.SearchingMethod.Static.Dat = (arr[11]);
		Antenna.Install.SearchingMethod.Searching.Dat = (arr[12]);
		Antenna.Install.SearchingMethod.Tracking.Dat = (arr[13]);
		Antenna.Install.SearchingMethod.Jog.Mode.Dat = (arr[80]);
		Antenna.Install.SearchingMethod.Asi.Pass.Dat = (arr[90]);
		Antenna.Install.SearchingMethod.Asi.MuteOnOff.Dat = (arr[91]);
		Antenna.Install.SearchingMethod.Asi.MuteThreshold.Dat = (arr[92]);  
		
		//console.log(arr[80])

		Antenna.Install.SkewMethod.MethodType.Dat = (arr[70]);
		Antenna.Install.SkewMethod.TypeString.Dat = (arr[71]);
		Antenna.Install.SkewMethod.Angle.Dat = (arr[72]);
		
		Antenna.Install.AcuNetwork.Ip0v4.Addr.Dat = (arr[360]);
		Antenna.Install.AcuNetwork.Ip0v4.Sn.Dat = (arr[361]);
		Antenna.Install.AcuNetwork.Ip0v4.Gw.Dat = (arr[362]);
		Antenna.Install.AcuNetwork.Ip1v4.Addr.Dat = (arr[363]);
		Antenna.Install.AcuNetwork.Ip1v4.Sn.Dat = (arr[364]);
		Antenna.Install.AcuNetwork.Ip1v4.Gw.Dat = (arr[365]);
		Antenna.Install.AcuNetwork.Port.Mnc.Dat = (arr[366]);
		Antenna.Install.AcuNetwork.Port.Abs.Dat = (arr[367]); 
		Antenna.Install.AcuNetwork.Port.Ttp.Dat = (arr[368]); 
		Antenna.Install.AcuNetwork.Port.Vcs.Dat = (arr[369]); 
		Antenna.Install.AcuNetwork.Mac.Dat = (arr[370]);
		Antenna.Install.AcuNetwork.ExtNetDev.Dat = (arr[371]);

		

		Antenna.Device.Pcu.Sn.Dat = (arr[200]);
		Antenna.Device.Pcu.FuncCode.Dat = (arr[201]);
		Antenna.Device.Pcu.ErrCode.Dat = (arr[202]);
		Antenna.Device.Pcu.Temperature.Dat = parseFloat(arr[203]);
		Antenna.Device.Pcu.Version.Dat = (arr[204]);
		Antenna.Device.Pcu.Volt.Dat = parseFloat(arr[205]);
		Antenna.Device.Pcu.Current.Dat = parseFloat(arr[206]);
		Antenna.Device.Pcu.ActivedSlot.Dat = (arr[209]);

		Antenna.Device.Acu.Sn.Dat = (arr[210]);
		Antenna.Device.Acu.Pn.Dat = (arr[211]);
		Antenna.Device.Acu.ErrCode.Dat = (arr[212]);
		Antenna.Device.Acu.Temperature.Dat = parseFloat(arr[213]);
		Antenna.Device.Acu.Version.Dat = (arr[214]);
		Antenna.Device.Acu.Volt.Dat = parseFloat(arr[215]);
		Antenna.Device.Acu.Current.Dat = parseFloat(arr[216]);
		Antenna.Device.Acu.ActivedSlot.Dat = (arr[249]);

		Antenna.Device.Buc.Sn.Dat = (arr[250]);
		Antenna.Device.Buc.Pn.Dat = (arr[251]);
		Antenna.Device.Buc.OutPower.Dat = (arr[252]);
		Antenna.Device.Buc.Temperature.Dat = parseFloat(arr[253]);
		Antenna.Device.Buc.Volt.Dat = parseFloat(arr[254]);
		Antenna.Device.Buc.Attn.Dat = parseFloat(arr[255]);
		Antenna.Device.Buc.TxOn.Dat = (arr[256]);
		Antenna.Device.Buc.Fan.Dat = (arr[257]);
		Antenna.Device.Buc.PllLock.Dat = (arr[258]);
		Antenna.Device.Buc.Mute.Dat = (arr[259]);
		Antenna.Device.Buc.IsOverTemperature.Dat = (arr[260]);
		Antenna.Device.Buc.IsOverPower.Dat = (arr[261]);
		Antenna.Device.Buc.IsDataIn.Dat = (arr[262]);
		Antenna.Device.Buc.Model.Dat = (arr[263]);
		Antenna.Device.Buc.Version.Dat = (arr[264]);
	
		Antenna.Device.Lnb.Sn.Dat = (arr[270]);
		Antenna.Device.Lnb.Version.Dat = (arr[271]);
	
		Antenna.Device.BdMux.TxMuteSwitch.Dat = (arr[280]); 
		Antenna.Device.BdMux.Ref10MHzSwitch.Dat = (arr[281]); 
		Antenna.Device.BdMux.Version.Dat = (arr[282]); 
		

		Antenna.AcuFunc.Exceptions.PcuDfu.Dat = (arr[400]);  /* ExtOpt - 1 */
		Antenna.AcuFunc.Exceptions.PcuConn.Dat = (arr[401]);  /* ExtOpt - 2 */
		Antenna.AcuFunc.Exceptions.AutoGain.Dat = (arr[402]);  /* ExtOpt - 4 */
		
		Antenna.AcuFunc.Notification.Moisture.Dat = (arr[420]);  /* Noti - 0 */
		
		Antenna.AcuFunc.Pub.SupprtModel.Dat = (arr[430]);  
		Antenna.AcuFunc.Pub.UseTleUI.Dat = (arr[431]); 
		Antenna.AcuFunc.Pub.LanguageType.Dat = (arr[432]); 
		Antenna.AcuFunc.Pub.BucPwrSync.Dat = (arr[433]); 
		Antenna.AcuFunc.Pub.IsUpdatePcu.Dat = (arr[434]);  
		
		
		Antenna.Device.Acu.IO.DecRef.Dat = (arr[380]);
		Antenna.Device.Acu.IO.Sw0.Dat = (arr[381]);
		Antenna.Device.Acu.IO.Sw1.Dat = (arr[382]);
		Antenna.Device.Acu.IO.Sw2.Dat = (arr[383]);
		Antenna.Device.Acu.IO.Sw3.Dat = (arr[384]);
		Antenna.Device.Acu.IO.FrontType.Dat = (arr[385]);
		/* Check Bdmux module type */
		if(Antenna.Device.Acu.IO.Sw3.Dat!=0) Antenna.Device.Acu.IO.Emc0.Type = Antenna.Device.Acu.IO.Emc1.Type = Antenna.Device.Acu.IO.Emc2.Type = Antenna.Device.Acu.IO.EmcSw.Type = 0x00001002;
		else Antenna.Device.Acu.IO.Emc0.Type = Antenna.Device.Acu.IO.Emc1.Type = Antenna.Device.Acu.IO.Emc2.Type = Antenna.Device.Acu.IO.Emc3.Type = Antenna.Device.Acu.IO.EmcSw.Type = 0x00000000;
		Antenna.Device.Acu.IO.Emc0.Dat = (arr[386]);
		Antenna.Device.Acu.IO.Emc1.Dat = (arr[387]);
		Antenna.Device.Acu.IO.Emc2.Dat = (arr[388]);
		Antenna.Device.Acu.IO.EmcSw.Dat = (arr[390]);
		

		Antenna.Interworking.Gps.UseSrc.Dat = (arr[100]);
		Antenna.Interworking.Gps.Status.Dat = (arr[101])==0?(arr[101]):(arr[101])==1?(arr[102]):(arr[100]);
		Antenna.Interworking.Gps.IsValids.Internal.Dat = (arr[101]);
		Antenna.Interworking.Gps.IsValids.External.Dat = (arr[102]);
		Antenna.Interworking.Gps.Values.IntLatitude.Dat = parseFloat(arr[103]);
		Antenna.Interworking.Gps.Values.IntLongitude.Dat = parseFloat(arr[104]);
		Antenna.Interworking.Gps.Values.IntSpeed.Dat = parseFloat(arr[105]);
		Antenna.Interworking.Gps.Values.IntTrackAngle.Dat = parseFloat(arr[106]);
		Antenna.Interworking.Gps.Values.ExtLatitude.Dat = parseFloat(arr[107]);
		Antenna.Interworking.Gps.Values.ExtLongitude.Dat = parseFloat(arr[108]);
		Antenna.Interworking.Gps.Values.ManualLatitude.Dat = parseFloat(arr[109]);
		Antenna.Interworking.Gps.Values.ManualLongitude.Dat = parseFloat(arr[110]);
		Antenna.Interworking.Gps.Values.UseLatitude.Dat = parseFloat(arr[111]);
		Antenna.Interworking.Gps.Values.UseLongitude.Dat = parseFloat(arr[112]);
		Antenna.Interworking.Gps.GpsOutFormat.Symbol.Dat = (arr[113]);
		Antenna.Interworking.Gps.GpsOutFormat.Type.Dat = (arr[114]);
		Antenna.Interworking.Gps.Interface.BaudRate.Dat = (arr[115]);
		
		Antenna.Interworking.Gyro.UseSrc.Dat = (arr[120]); 
		Antenna.Interworking.Gyro.IsValids.Nmea2000.Dat = (arr[121]); 
		Antenna.Interworking.Gyro.IsValids.Nmea0183.Dat = (arr[122]); 
		Antenna.Interworking.Gyro.IsValids.SyncStep.Dat = (arr[123]);
		Antenna.Interworking.Gyro.Values.Use.Dat = parseFloat(arr[128]); 
		Antenna.Interworking.Gyro.Values.Manual.Dat = parseFloat(arr[124]);
		Antenna.Interworking.Gyro.Values._Nmea2000.Dat = parseFloat(arr[125]); 
		Antenna.Interworking.Gyro.Values._Nmea0183.Dat = parseFloat(arr[126]); 
		Antenna.Interworking.Gyro.Values._SyncStep.Dat = parseFloat(arr[127]); 
		Antenna.Interworking.Gyro.Setting.UseNMEA2000Gui.Dat = (arr[129]);
		Antenna.Interworking.Gyro.Setting.Type.Dat = (arr[130]); 
		Antenna.Interworking.Gyro.Interface.BaudRate.Dat = (arr[131]);  
		Antenna.Interworking.Gyro.Interface.Direction.Dat = (arr[132]);  
		Antenna.Interworking.Gyro.Interface.SyncFreq.Dat = (arr[133]);  
		Antenna.Interworking.Gyro.Interface.Converter.Dat = parseFloat(arr[134]);   
			
		Antenna.Interworking.Console.IsUse.Dat = (arr[140]); 
		Antenna.Interworking.Console.LockTTL.Dat = (arr[141]); 
		Antenna.Interworking.Console.GpsOutFormat.Symbol.Dat = (arr[142]); 
		Antenna.Interworking.Console.GpsOutFormat.Type.Dat = (arr[143]); 
		Antenna.Interworking.Console.Interface.BaudRate.Dat = (arr[144]); 
		
			
		Antenna.Interworking.ABS.IsConnected.Dat = (arr[181]); 
		Antenna.Interworking.ABS.RcvCnt.Dat = (arr[182]); 	
		Antenna.Interworking.ABS.IsUse.Dat = (arr[183]); 
		Antenna.Interworking.ABS.ModemClass.Dat = (arr[184]); 
		Antenna.Interworking.ABS.ProtocolType.Dat = (arr[185]); 
		Antenna.Interworking.ABS.ExtLockSrc.Dat = (arr[186]); 
		Antenna.Interworking.ABS.LnbBand1Lo.Dat = (arr[187]); 
		Antenna.Interworking.ABS.LnbBand2Lo.Dat = (arr[188]); 
		Antenna.Interworking.ABS.LnbBand3Lo.Dat = (arr[189]); 
		Antenna.Interworking.ABS.LnbBand4Lo.Dat = (arr[190]); 
		Antenna.Interworking.ABS.RollOff.Dat = (arr[191]); 
		Antenna.Interworking.ABS.RfTermType.Dat = (arr[192]); 
		Antenna.Interworking.ABS.RfTermType.Dat = (arr[192]); 
		Antenna.Interworking.ABS.Port.Dat = (arr[367]); 
				
		Antenna.Interworking.Vcs.IsUse.Dat = (arr[300]); 
		Antenna.Interworking.Vcs.IsConnected.Dat = (arr[301]); 
		Antenna.Interworking.Vcs.RecvCnt.Dat = (arr[302]); 
		Antenna.Interworking.Vcs.Port.Dat = (arr[369]);
		
		Antenna.Interworking.Mnc.IsUse.Dat = (arr[310]); 
		Antenna.Interworking.Mnc.IsConnected.Dat = (arr[311]); 
		Antenna.Interworking.Mnc.Port.Dat = (arr[366]);
		
		Antenna.Interworking.Ttp.IsUse.Dat = (arr[320]); 
		Antenna.Interworking.Ttp.IsConnected.Dat = (arr[321]); 
		Antenna.Interworking.Ttp.Port.Dat = (arr[368]); 

 
		Antenna.Dashboard.Signal.NimAGC.Dat = (arr[20]);
		Antenna.Dashboard.Signal.NimQuality.Dat = (arr[21]);
		Antenna.Dashboard.Signal.Rssd.Dat = (arr[22]); 
		Antenna.Dashboard.Signal.RssdCn.Dat = (arr[23]); 
		Antenna.Dashboard.LookAngle.Elevation.Dat = parseFloat(arr[40]);
		Antenna.Dashboard.LookAngle.Azimuth.Dat = parseFloat(arr[41]);
		Antenna.Dashboard.LookAngle.Relative.Dat = parseFloat(arr[42]);
		Antenna.Dashboard.LookAngle.RefBank.Dat = parseFloat(arr[43]);
		Antenna.Dashboard.LookAngle.RefElevation.Dat = parseFloat(arr[44]); 
		Antenna.Dashboard.LookAngle.RefAzimuth.Dat = parseFloat(arr[45]);
		Antenna.Dashboard.LookAngle.Tilt.Dat = parseFloat(arr[46]);
		Antenna.Dashboard.LookAngle.Level.Dat = parseFloat(arr[47]);
		Antenna.Dashboard.LookAngle.Yaw.Dat = parseFloat(arr[48]);
		Antenna.Dashboard.LookAngle.AhrsRoll.Dat = parseFloat(arr[49]); 
		Antenna.Dashboard.LookAngle.AhrsPitch.Dat = parseFloat(arr[50]);
		Antenna.Dashboard.LookAngle.AhrsYaw.Dat = parseFloat(arr[51]);
 
		Antenna.Dashboard.Target.ID.Dat = (arr[150]);
		Antenna.Dashboard.Target.Name.Dat = (arr[151]);
		Antenna.Dashboard.Target.Position.Dat = (arr[152]);
		Antenna.Dashboard.Target.RxBand.Dat = (arr[153]);
		Antenna.Dashboard.Target.RxBandString.Dat = (arr[154]);
		Antenna.Dashboard.Target.RxPolarity.Dat = (arr[155]);
		Antenna.Dashboard.Target.RxPolarityString.Dat = (arr[156]);
		Antenna.Dashboard.Target.TxBand.Dat = (arr[157]);
		Antenna.Dashboard.Target.TxBandString.Dat = (arr[158]);
		Antenna.Dashboard.Target.TxPolarity.Dat = (arr[159]);
		Antenna.Dashboard.Target.TxPolarityString.Dat = (arr[160]);
		Antenna.Dashboard.Target.TRxPolarity.Dat = (arr[161]);
		Antenna.Dashboard.Target.TRxPolarityString.Dat = (arr[162]);
		Antenna.Dashboard.Target.SearchingType.Dat = (arr[163]);
		Antenna.Dashboard.Target.SearchingTypeString.Dat = (arr[164]);
		Antenna.Dashboard.Target.TrackingType.Dat = (arr[165]);
		Antenna.Dashboard.Target.TrackingTypeString.Dat = (arr[166]); 
		
		
		Antenna.Dashboard.Operating.Driving.OnOff.Dat = (arr[10]);
		Antenna.Dashboard.Operating.Driving.Gps.Dat = Antenna.Interworking.Gps.IsValids.Internal.Dat | Antenna.Interworking.Gps.IsValids.External.Dat;
		Antenna.Dashboard.Operating.Driving.Gyro.Dat = Antenna.Interworking.Gyro.IsValids.Nmea2000.Dat | Antenna.Interworking.Gyro.IsValids.Nmea0183.Dat | Antenna.Interworking.Gyro.IsValids.SyncStep.Dat;
		Antenna.Dashboard.Operating.Initialize.Compass.Dat = Antenna.Dashboard.Link.CompassMode.Dat;
		Antenna.Dashboard.Operating.Initialize.CompassString.Dat = Antenna.Dashboard.Link.CompassModeString.Dat;
		Antenna.Dashboard.Operating.Searching.Operating.Dat = Antenna.Install.SearchingMethod.MethodType.Dat;
		Antenna.Dashboard.Operating.Searching.OperatingString.Dat = Antenna.Install.SearchingMethod.TypeString.Dat;
		Antenna.Dashboard.Operating.Searching.Skew.Dat = Antenna.Install.SkewMethod.MethodType.Dat;
		Antenna.Dashboard.Operating.Searching.SkewString.Dat = Antenna.Install.SkewMethod.TypeString.Dat;
		Antenna.Dashboard.Operating.Searching.Reference.Dat = Antenna.Dashboard.Target.SearchingType.Dat;
		Antenna.Dashboard.Operating.Searching.ReferenceString.Dat =  Antenna.Dashboard.Target.SearchingTypeString.Dat;
		Antenna.Dashboard.Operating.Searching.RefThreshold.Dat = 0;
		Antenna.Dashboard.Operating.Tracking.Reference.Dat = Antenna.Dashboard.Target.TrackingType.Dat;
		Antenna.Dashboard.Operating.Tracking.ReferenceString.Dat = Antenna.Dashboard.Target.TrackingTypeString.Dat;
		Antenna.Dashboard.Operating.Tracking.DecTxLoFreq.Dat = Antenna.Device.Acu.IO.DecRef.Dat;
		 
	},
	UpdateSatelliteFromArray : function(arr) {
		/* web - event 30 - 2*/
		var cmp_cnt = 0;
		if(Antenna.SatelliteChannel.Zone.Dat != (arr[0])) cmp_cnt++;
		if(Antenna.SatelliteChannel.ID.Dat != (arr[19])) cmp_cnt++; 
		if(Antenna.SatelliteChannel.Name.Dat != (arr[1])) cmp_cnt++;
		if(Antenna.SatelliteChannel.Position.Dat != parseFloat(arr[2])) cmp_cnt++;
		if(Antenna.SatelliteChannel.TransportFrequency.Dat != (arr[7])) cmp_cnt++;
		if(Antenna.SatelliteChannel.TransportSymbolRate.Dat != (arr[8])) cmp_cnt++;
		if(Antenna.SatelliteChannel.RxBand.Dat != (arr[3])) cmp_cnt++;
		if(Antenna.SatelliteChannel.RxPolarity.Dat != (arr[15])) cmp_cnt++;
		if(Antenna.SatelliteChannel.TxBand.Dat != (arr[7])) cmp_cnt++;
		if(Antenna.SatelliteChannel.TxPolarity.Dat != (arr[18])) cmp_cnt++;
		if(Antenna.SatelliteChannel.TRxPolarity.Dat != (arr[14])) cmp_cnt++;
		if(Antenna.SatelliteChannel.SearchingType.Dat != (arr[11])) cmp_cnt++;
		if(Antenna.SatelliteChannel.TrackingType.Dat != (arr[12])) cmp_cnt++;
		if(Antenna.SatelliteChannel.Threshold.Dat != (arr[3])) cmp_cnt++;
		if(Antenna.SatelliteChannel.SkewTrimmingAngle.Dat != (arr[4])) cmp_cnt++;
		if(Antenna.SatelliteChannel.BucLoFrequency.Dat != (arr[17])) cmp_cnt++;
		if(Antenna.SatelliteChannel.LnbLowLoFrequency.Dat != (arr[5])) cmp_cnt++;
		if(Antenna.SatelliteChannel.LnbHighLoFrequency.Dat != (arr[6])) cmp_cnt++;
		if(Antenna.SatelliteChannel.LnbBandSelection.Dat != (arr[16])) cmp_cnt++;
		if(Antenna.SatelliteChannel.NID.Dat != (arr[10])) cmp_cnt++;
		if(Antenna.SatelliteChannel.RollOff.Dat != (arr[9])) cmp_cnt++;
		if(Antenna.SatelliteChannel.VT.Dat != (arr[13])) cmp_cnt++;
		
		Antenna.SatelliteChannel.Zone.Dat = (arr[0]); 
		Antenna.SatelliteChannel.ID.Dat = (arr[19]); 
		Antenna.SatelliteChannel.Name.Dat = (arr[1]);
		Antenna.SatelliteChannel.Position.Dat = parseFloat(arr[2]);
		Antenna.SatelliteChannel.TransportFrequency.Dat = (arr[7]);
		Antenna.SatelliteChannel.TransportSymbolRate.Dat = (arr[8]);
		Antenna.SatelliteChannel.RxBand.Dat = (arr[3]);
		Antenna.SatelliteChannel.RxPolarity.Dat = (arr[15]);
		Antenna.SatelliteChannel.TxBand.Dat = (arr[7]);
		Antenna.SatelliteChannel.TxPolarity.Dat = (arr[18]);
		Antenna.SatelliteChannel.TRxPolarity.Dat = (arr[14]);
		Antenna.SatelliteChannel.SearchingType.Dat = (arr[11]);
		Antenna.SatelliteChannel.TrackingType.Dat = (arr[12]);
		Antenna.SatelliteChannel.Threshold.Dat = (arr[3]);
		Antenna.SatelliteChannel.SkewTrimmingAngle.Dat = (arr[4]);
		Antenna.SatelliteChannel.BucLoFrequency.Dat = (arr[17]);
		Antenna.SatelliteChannel.LnbLowLoFrequency.Dat = (arr[5]);
		Antenna.SatelliteChannel.LnbHighLoFrequency.Dat = (arr[6]);
		Antenna.SatelliteChannel.LnbBandSelection.Dat = (arr[16]);
		Antenna.SatelliteChannel.NID.Dat = (arr[10]);
		Antenna.SatelliteChannel.RollOff.Dat = (arr[9]);
		Antenna.SatelliteChannel.VT.Dat = (arr[13]);

		return cmp_cnt;
	},
 };
		